import { Column, Entity, ManyToOne, PrimaryGeneratedColumn } from 'typeorm';
import { Author } from './author';

@Entity()
export class AuthorName implements AuthorNameEntityInterface {
  @PrimaryGeneratedColumn()
  public readonly id!: number;

  @ManyToOne(() => Author, (author: AuthorEntityInterface) => author.names, {
    nullable: false,
    onDelete: 'CASCADE',
    onUpdate: 'CASCADE',
  })
  public entity!: Promise<AuthorEntityInterface>;

  @Column({
    nullable: false,
    default: '',
  })
  public name!: string;
}
