import { Column, Entity, ManyToOne, PrimaryGeneratedColumn } from 'typeorm';
import { Site } from './site';

@Entity()
export class SiteName implements SiteNameEntityInterface {
  @PrimaryGeneratedColumn()
  public readonly id!: number;

  @ManyToOne(() => Site, (site: SiteEntityInterface) => site.names, {
    nullable: false,
    onDelete: 'CASCADE',
    onUpdate: 'CASCADE',
  })
  public entity!: Promise<SiteEntityInterface>;

  @Column({
    nullable: false,
    default: '',
  })
  public name!: string;
}
