import { Column, Entity, ManyToOne, PrimaryGeneratedColumn } from 'typeorm';
import { WorkCharacter } from './work-character';

@Entity()
export class WorkCharacterName implements WorkCharacterNameEntityInterface {
  @PrimaryGeneratedColumn()
  public readonly id!: number;

  @ManyToOne(() => WorkCharacter, (workCharacter: WorkCharacterEntityInterface) => workCharacter.names, {
    nullable: false,
    onDelete: 'CASCADE',
    onUpdate: 'CASCADE',
  })
  public entity!: Promise<WorkCharacterEntityInterface>;

  @Column({
    nullable: false,
    default: '',
  })
  public name!: string;
}
