import { Column, Entity, ManyToOne, PrimaryGeneratedColumn } from 'typeorm';
import { Work } from './work';

@Entity()
export class WorkName implements WorkNameEntityInterface {
  @PrimaryGeneratedColumn()
  public readonly id!: number;

  @ManyToOne(() => Work, (work: WorkEntityInterface) => work.names, {
    nullable: false,
    onDelete: 'CASCADE',
    onUpdate: 'CASCADE',
  })
  public entity!: Promise<WorkEntityInterface>;

  @Column({
    nullable: false,
    default: '',
  })
  public name!: string;
}
