import { Column, Entity, ManyToOne, PrimaryGeneratedColumn } from 'typeorm';
import { WorldCharacter } from './world-character';

@Entity()
export class WorldCharacterName implements WorldCharacterNameEntityInterface {
  @PrimaryGeneratedColumn()
  public readonly id!: number;

  @ManyToOne(() => WorldCharacter, (worldCharacter: WorldCharacterEntityInterface) => worldCharacter.names, {
    nullable: false,
    onDelete: 'CASCADE',
    onUpdate: 'CASCADE',
  })
  public entity!: Promise<WorldCharacterEntityInterface>;

  @Column({
    nullable: false,
    default: '',
  })
  public name!: string;
}
