import { Column, Entity, ManyToOne, PrimaryGeneratedColumn } from 'typeorm';
import { World } from './world';

@Entity()
export class WorldName implements WorldNameEntityInterface {
  @PrimaryGeneratedColumn()
  public readonly id!: number;

  @ManyToOne(() => World, (world: WorldEntityInterface) => world.names, {
    nullable: false,
    onDelete: 'CASCADE',
    onUpdate: 'CASCADE',
  })
  public entity!: Promise<WorldEntityInterface>;

  @Column({
    nullable: false,
    default: '',
  })
  public name!: string;
}
