import path from 'path';
import { injectable } from 'inversify';
import { Service } from '../../core/container';
import { inject } from '../../core/inject';
import { FileAppWindow } from './file-app-window';

@injectable()
export class MainAppWindow extends FileAppWindow {
  public constructor(@inject(Service.LOGGER) logger: LoggerInterface) {
    super(logger, 'frontend/index.html', {
      webPreferences: {
        preload: path.resolve('src/preload.js'),
      },
    });
  }
}
