import chai, { expect } from 'chai';
import deepEqualInAnyOrder from 'deep-equal-in-any-order';
import { before, describe, it } from 'mocha';
import { container, Service } from '../../core/container';
import { LoggerMock } from '../logger/logger.mock';

chai.use(deepEqualInAnyOrder);

describe('Nhentai App Window', () => {
  before(() => {
    container.unbind(Service.LOGGER);
    container.bind(Service.LOGGER).to(LoggerMock);
  });

  it('gets the gallery information from an identifier @slow', async () => {
    const nhentaiAppWindow = container.get(Service.NHENTAI_APP_WINDOW);

    let expectedGallery: Nhentai.Gallery = {
      url: 'https://nhentai.net/g/107386/',
      title: {
        pre: '[Homunculus]',
        main: 'Renai Sample + Bonus Booklets',
        post: '[English] [Tankoubon version]',
      },
      artists: ['homunculus'],
      groups: [],
      parodies: [],
      characters: [],
      tags: [
        'group',
        'stockings',
        'schoolgirl uniform',
        'glasses',
        'incest',
        'tankoubon',
        'defloration',
        'milf',
        'swimsuit',
        'ffm threesome',
        'impregnation',
        'sister',
        'schoolboy uniform',
        'bikini',
        'teacher',
        'apron',
        'inseki',
        'leg lock',
        'cousin',
        'niece',
      ],
      languages: ['english', 'translated'],
      uploadTime: 1404001890940,
    };
    let gallery = await nhentaiAppWindow.getGallery('107386');
    expect(gallery).deep.equalInAnyOrder(expectedGallery, 'Renai Sample is not got correctly');

    expectedGallery = {
      url: 'https://nhentai.net/g/273405/',
      title: {
        pre: '(COMIC1☆12) [MOSQUITONE. (Great Mosu)]',
        main: 'Koisuru Dai Akuma | The Archdemon In Love',
        post: '(Gabriel DropOut) [English] {Tanjoubi + Hennojin} [Decensored]',
      },
      artists: ['great mosu'],
      groups: ['mosquitone.'],
      parodies: ['gabriel dropout'],
      characters: ['satanichia kurumizawa mcdowell'],
      tags: ['sole female', 'sole male', 'defloration', 'uncensored', 'kissing'],
      languages: ['english', 'translated'],
      uploadTime: 1558833881932,
    };
    gallery = await nhentaiAppWindow.getGallery('273405');
    expect(gallery).deep.equalInAnyOrder(expectedGallery, 'The Archdemon in Love is not got correctly!');
  }).timeout(0);
});
