export abstract class Serializer<
  Entity extends IdentifiableInterface<Id>,
  Serialized extends IdentifiableInterface<Id>,
  Id extends Identifier = number,
> {
  public abstract serialize(entity: Entity): Promise<Serialized>;

  public abstract deserialize(partial: Partial<Serialized>): Partial<Entity>;
}
