import { injectable } from 'inversify';
import { Author } from '../../../entities/library/author';
import { getDeserializedEntityPromise } from '../get-deserialized';
import { serializeName } from '../serialize-name';
import { Serializer } from '../serializer';

@injectable()
export class AuthorNameSerializer extends Serializer<AuthorNameEntityInterface, AuthorNameSerializedInterface> {
  public serialize(entity: AuthorNameEntityInterface): Promise<AuthorNameSerializedInterface> {
    return serializeName(entity);
  }

  public deserialize(partial: Partial<AuthorNameSerializedInterface>): Partial<AuthorNameEntityInterface> {
    return {
      ...(partial.id ? { id: partial.id } : {}),
      ...(partial.name ? { name: partial.name } : {}),
      ...(partial.entity ? { entity: getDeserializedEntityPromise(partial.entity, Author) } : {}),
    };
  }
}
