import { injectable } from 'inversify';
import { Collection } from '../../../entities/library/collection';
import { getDeserializedEntityPromise } from '../get-deserialized';
import { serializeName } from '../serialize-name';
import { Serializer } from '../serializer';

@injectable()
export class CollectionNameSerializer extends Serializer<
  CollectionNameEntityInterface,
  CollectionNameSerializedInterface
> {
  public serialize(entity: CollectionNameEntityInterface): Promise<CollectionNameSerializedInterface> {
    return serializeName(entity);
  }

  public deserialize(partial: Partial<CollectionNameSerializedInterface>): Partial<CollectionNameEntityInterface> {
    return {
      ...(partial.id ? { id: partial.id } : {}),
      ...(partial.name ? { name: partial.name } : {}),
      ...(partial.entity ? { entity: getDeserializedEntityPromise(partial.entity, Collection) } : {}),
    };
  }
}
