import { injectable } from 'inversify';
import { Site } from '../../../entities/library/site';
import { getDeserializedEntityPromise } from '../get-deserialized';
import { serializeName } from '../serialize-name';
import { Serializer } from '../serializer';

@injectable()
export class SiteNameSerializer extends Serializer<SiteNameEntityInterface, SiteNameSerializedInterface> {
  public serialize(entity: SiteNameEntityInterface): Promise<SiteNameSerializedInterface> {
    return serializeName(entity);
  }

  public deserialize(partial: Partial<SiteNameSerializedInterface>): Partial<SiteNameEntityInterface> {
    return {
      ...(partial.id ? { id: partial.id } : {}),
      ...(partial.name ? { name: partial.name } : {}),
      ...(partial.entity ? { entity: getDeserializedEntityPromise(partial.entity, Site) } : {}),
    };
  }
}
