import { injectable } from 'inversify';
import { Tag } from '../../../entities/library/tag';
import { getDeserializedEntityPromise } from '../get-deserialized';
import { serializeName } from '../serialize-name';
import { Serializer } from '../serializer';

@injectable()
export class TagNameSerializer extends Serializer<TagNameEntityInterface, TagNameSerializedInterface> {
  public serialize(entity: TagNameEntityInterface): Promise<TagNameSerializedInterface> {
    return serializeName(entity);
  }

  public deserialize(partial: Partial<TagNameSerializedInterface>): Partial<TagNameEntityInterface> {
    return {
      ...(partial.id ? { id: partial.id } : {}),
      ...(partial.name ? { name: partial.name } : {}),
      ...(partial.entity ? { entity: getDeserializedEntityPromise(partial.entity, Tag) } : {}),
    };
  }
}
