import { injectable } from 'inversify';
import { WorkCharacter } from '../../../entities/library/work-character';
import { getDeserializedEntityPromise } from '../get-deserialized';
import { serializeName } from '../serialize-name';
import { Serializer } from '../serializer';

@injectable()
export class WorkCharacterNameSerializer extends Serializer<
  WorkCharacterNameEntityInterface,
  WorkCharacterNameSerializedInterface
> {
  public serialize(entity: WorkCharacterNameEntityInterface): Promise<WorkCharacterNameSerializedInterface> {
    return serializeName(entity);
  }

  public deserialize(
    partial: Partial<WorkCharacterNameSerializedInterface>,
  ): Partial<WorkCharacterNameEntityInterface> {
    return {
      ...(partial.id ? { id: partial.id } : {}),
      ...(partial.name ? { name: partial.name } : {}),
      ...(partial.entity ? { entity: getDeserializedEntityPromise(partial.entity, WorkCharacter) } : {}),
    };
  }
}
