import { injectable } from 'inversify';
import { Work } from '../../../entities/library/work';
import { getDeserializedEntityPromise } from '../get-deserialized';
import { serializeName } from '../serialize-name';
import { Serializer } from '../serializer';

@injectable()
export class WorkNameSerializer extends Serializer<WorkNameEntityInterface, WorkNameSerializedInterface> {
  public serialize(entity: WorkNameEntityInterface): Promise<WorkNameSerializedInterface> {
    return serializeName(entity);
  }

  public deserialize(partial: Partial<WorkNameSerializedInterface>): Partial<WorkNameEntityInterface> {
    return {
      ...(partial.id ? { id: partial.id } : {}),
      ...(partial.name ? { name: partial.name } : {}),
      ...(partial.entity ? { entity: getDeserializedEntityPromise(partial.entity, Work) } : {}),
    };
  }
}
