import { injectable } from 'inversify';
import { WorldCharacter } from '../../../entities/library/world-character';
import { getDeserializedEntityPromise } from '../get-deserialized';
import { serializeName } from '../serialize-name';
import { Serializer } from '../serializer';

@injectable()
export class WorldCharacterNameSerializer extends Serializer<
  WorldCharacterNameEntityInterface,
  WorldCharacterNameSerializedInterface
> {
  public serialize(entity: WorldCharacterNameEntityInterface): Promise<WorldCharacterNameSerializedInterface> {
    return serializeName(entity);
  }

  public deserialize(
    partial: Partial<WorldCharacterNameSerializedInterface>,
  ): Partial<WorldCharacterNameEntityInterface> {
    return {
      ...(partial.id ? { id: partial.id } : {}),
      ...(partial.name ? { name: partial.name } : {}),
      ...(partial.entity ? { entity: getDeserializedEntityPromise(partial.entity, WorldCharacter) } : {}),
    };
  }
}
