declare namespace Session {
  type CspValue = '*' | "'none'" | "'self'" | "'unsafe-inline'" | "'unsafe-eval'" | string;

  /**
   * This interface represents a content security policy.
   *
   * @see https://www.w3.org/TR/CSP/
   * @see https://content-security-policy.com/
   */
  type ContentSecurityPolicy = {
    'child-src'?: CspValue[];
    'connect-src'?: CspValue[];
    'default-src'?: CspValue[];
    'font-src'?: CspValue[];
    'frame-src'?: CspValue[];
    'img-src'?: CspValue[];
    'media-src'?: CspValue[];
    'script-src'?: CspValue[];
    'script-src-elem'?: CspValue[];
    'script-src-attr'?: CspValue[];
    'style-src'?: CspValue[];
    'style-src-elem'?: CspValue[];
    'style-src-attr'?: CspValue[];
    'worker-src'?: CspValue[];
  };
}
