import type { IpcRenderer } from 'electron';

// @ts-ignore -- https://www.electronjs.org/docs/latest/tutorial/context-isolation
const ipcRenderer: IpcRenderer = window.ipcRenderer as IpcRenderer;

export const ipcClient: IpcClient = {
  ask<T extends IpcChannel>(channel: T, data?: IpcParameter<T>): Promise<IpcAnswer<T>> {
    return ipcRenderer.invoke(channel, data) as Promise<IpcAnswer<T>>;
  },
};
