import { entityApi } from '../../../services/api';
import type { EditableEntityRepositoryInterface } from '../editable-entity-repository';
import { NameEntityRepository } from '../name-entity-repository';

const authorRepositoryPromise = import('./author-repository').then((m) => m.authorRepository);

export const authorNameRepository: EditableEntityRepositoryInterface<AuthorNameSerializedInterface> =
  new NameEntityRepository(
    (id) => entityApi.readAuthorName(id),
    (partial) => entityApi.createAuthorName(partial),
    (id, partial) => entityApi.updateAuthorName(id, partial),
    (id) => entityApi.deleteAuthorName(id),
    authorRepositoryPromise,
  );
