import { entityApi } from '../../../services/api';
import type { EditableEntityRepositoryInterface } from '../editable-entity-repository';
import { NameEntityRepository } from '../name-entity-repository';

const authorRoleRepositoryPromise = import('./author-role-repository').then((m) => m.authorRoleRepository);

export const authorRoleNameRepository: EditableEntityRepositoryInterface<AuthorNameSerializedInterface> =
  new NameEntityRepository(
    (id) => entityApi.readAuthorRoleName(id),
    (partial) => entityApi.createAuthorRoleName(partial),
    (id, partial) => entityApi.updateAuthorRoleName(id, partial),
    (id) => entityApi.deleteAuthorRoleName(id),
    authorRoleRepositoryPromise,
  );
