import { entityApi } from '../../../services/api';
import type { EditableEntityRepositoryInterface } from '../editable-entity-repository';
import { NameEntityRepository } from '../name-entity-repository';

const collectionRepositoryPromise = import('./collection-repository').then((m) => m.collectionRepository);

export const collectionNameRepository: EditableEntityRepositoryInterface<CollectionNameSerializedInterface> =
  new NameEntityRepository(
    (id) => entityApi.readCollectionName(id),
    (partial) => entityApi.createCollectionName(partial),
    (id, partial) => entityApi.updateCollectionName(id, partial),
    (id) => entityApi.deleteCollectionName(id),
    collectionRepositoryPromise,
  );
