import { entityApi } from '../../../services/api';
import type { EditableEntityRepositoryInterface } from '../editable-entity-repository';
import { NameEntityRepository } from '../name-entity-repository';

const siteRepositoryPromise = import('./site-repository').then((m) => m.siteRepository);

export const siteNameRepository: EditableEntityRepositoryInterface<SiteNameSerializedInterface> =
  new NameEntityRepository(
    (id) => entityApi.readSiteName(id),
    (partial) => entityApi.createSiteName(partial),
    (id, partial) => entityApi.updateSiteName(id, partial),
    (id) => entityApi.deleteSiteName(id),
    siteRepositoryPromise,
  );
