import { entityApi } from '../../../services/api';
import type { EditableEntityRepositoryInterface } from '../editable-entity-repository';
import { NameEntityRepository } from '../name-entity-repository';

const tagRepositoryPromise = import('./tag-repository').then((m) => m.tagRepository);

export const tagNameRepository: EditableEntityRepositoryInterface<TagNameSerializedInterface> =
  new NameEntityRepository(
    (id) => entityApi.readTagName(id),
    (partial) => entityApi.createTagName(partial),
    (id, partial) => entityApi.updateTagName(id, partial),
    (id) => entityApi.deleteTagName(id),
    tagRepositoryPromise,
  );
