import { entityApi } from '../../../services/api';
import type { EditableEntityRepositoryInterface } from '../editable-entity-repository';
import { NameEntityRepository } from '../name-entity-repository';

const transformationTypeRepositoryPromise = import('./transformation-type-repository').then(
  (m) => m.transformationTypeRepository,
);

export const transformationTypeNameRepository: EditableEntityRepositoryInterface<TransformationTypeNameSerializedInterface> =
  new NameEntityRepository(
    (id) => entityApi.readTransformationTypeName(id),
    (partial) => entityApi.createTransformationTypeName(partial),
    (id, partial) => entityApi.updateTransformationTypeName(id, partial),
    (id) => entityApi.deleteTransformationTypeName(id),
    transformationTypeRepositoryPromise,
  );
