import { entityApi } from '../../../services/api';
import type { EditableEntityRepositoryInterface } from '../editable-entity-repository';
import { NameEntityRepository } from '../name-entity-repository';

const workCharacterRepositoryPromise = import('./work-character-repository').then((m) => m.workCharacterRepository);

export const workCharacterNameRepository: EditableEntityRepositoryInterface<WorkCharacterNameSerializedInterface> =
  new NameEntityRepository(
    (id) => entityApi.readWorkCharacterName(id),
    (partial) => entityApi.createWorkCharacterName(partial),
    (id, partial) => entityApi.updateWorkCharacterName(id, partial),
    (id) => entityApi.deleteWorkCharacterName(id),
    workCharacterRepositoryPromise,
  );
