import { entityApi } from '../../../services/api';
import type { EditableEntityRepositoryInterface } from '../editable-entity-repository';
import { NameEntityRepository } from '../name-entity-repository';

const workRepositoryPromise = import('./work-repository').then((m) => m.workRepository);

export const workNameRepository: EditableEntityRepositoryInterface<WorkNameSerializedInterface> =
  new NameEntityRepository(
    (id) => entityApi.readWorkName(id),
    (partial) => entityApi.createWorkName(partial),
    (id, partial) => entityApi.updateWorkName(id, partial),
    (id) => entityApi.deleteWorkName(id),
    workRepositoryPromise,
  );
