import { entityApi } from '../../../services/api';
import type { EditableEntityRepositoryInterface } from '../editable-entity-repository';
import { NameEntityRepository } from '../name-entity-repository';

const worldCharacterRepositoryPromise = import('./world-character-repository').then((m) => m.worldCharacterRepository);

export const worldCharacterNameRepository: EditableEntityRepositoryInterface<WorldCharacterNameSerializedInterface> =
  new NameEntityRepository(
    (id) => entityApi.readWorldCharacterName(id),
    (partial) => entityApi.createWorldCharacterName(partial),
    (id, partial) => entityApi.updateWorldCharacterName(id, partial),
    (id) => entityApi.deleteWorldCharacterName(id),
    worldCharacterRepositoryPromise,
  );
