import { entityApi } from '../../../services/api';
import type { EditableEntityRepositoryInterface } from '../editable-entity-repository';
import { NameEntityRepository } from '../name-entity-repository';

const worldRepositoryPromise = import('./world-repository').then((m) => m.worldRepository);

export const worldNameRepository: EditableEntityRepositoryInterface<WorldNameSerializedInterface> =
  new NameEntityRepository(
    (id) => entityApi.readWorldName(id),
    (partial) => entityApi.createWorldName(partial),
    (id, partial) => entityApi.updateWorldName(id, partial),
    (id) => entityApi.deleteWorldName(id),
    worldRepositoryPromise,
  );
