/**
 * A collection is a set of works.
 * For example, this can be a series or a set of alternate angles.
 * What constitutes as a collection is ultimately up to the user.
 *
 * As a general rule of thumb:
 * If authors of works see them as belonging together, they are a collection
 */
interface CollectionInterface extends IdentifiableInterface, MultiNamedInterface {
  names: Promise<CollectionNameInterface[]> | number[];

  /**
   * the connecting entity between this collection and the work
   */
  parts: Promise<CollectionPartInterface[]> | number[];
}
