/**
 * This entity describes a single name of an entity with multiple names.
 */
interface NameInterface<
  T extends MultiNamedInterface & IdentifiableInterface = MultiNamedInterface & IdentifiableInterface,
> extends IdentifiableInterface {
  /**
   * the name
   */
  name: string;

  /**
   * the entity to which the names belong
   */
  entity: Promise<T> | number;
}
