/**
 * This entity describes an external source of a copy, in most cases that is a website.
 */
interface SourceInterface extends IdentifiableInterface {
  /**
   * the uri to the sauce
   */
  uri: string;

  /**
   * the site connected to the source
   */
  site: Promise<SiteInterface> | number | null;

  /**
   * the copies which can be found here
   */
  copies: Promise<CopyInterface[]> | number[];
}
