/**
 * This entity connects authors with their work and their role therein.
 */
interface WorkAuthorInterface extends IdentifiableInterface, OrderableInterface {
  /**
   * the work
   */
  work: Promise<WorkInterface> | number;

  /**
   * the roles of the author in the work
   */
  authorRoles: Promise<AuthorRoleInterface[]> | number[];

  /**
   * the author
   */
  author: Promise<AuthorInterface> | number;
}
