/**
 * This entity describes a fictional world.
 */
interface WorldInterface extends IdentifiableInterface, MultiNamedInterface, HierarchicalInterface<WorldInterface> {
  names: Promise<WorldNameInterface[]> | number[];

  /**
   * works taking place in this world
   */
  works: Promise<WorkInterface[]> | number[];

  /**
   * canon characters in this world
   */
  worldCharacters: Promise<WorldCharacterInterface[]> | number[];
}
