/**
 * ISO 639-1 language codes
 * @see https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes
 */
declare const enum LangCode {
  ABKHAZIAN = 'ab',
  AFAR = 'aa',
  AFRIKAANS = 'af',
  AKAN = 'ak',
  ALBANIAN = 'sq',
  AMHARIC = 'am',
  ARABIC = 'ar',
  ARAGONESE = 'an',
  ARMENIAN = 'hy',
  ASSAMESE = 'as',
  AVARIC = 'av',
  AVESTAN = 'ae',
  AYMARA = 'ay',
  AZERBAIJANI = 'az',
  BAMBARA = 'bm',
  BASHKIR = 'ba',
  BASQUE = 'eu',
  BELARUSIAN = 'be',
  BENGALI = 'bn',
  BIHARI_LANGUAGES = 'bh',
  BISLAMA = 'bi',
  BOSNIAN = 'bs',
  BRETON = 'br',
  BULGARIAN = 'bg',
  BURMESE = 'my',
  CATALAN_VALENCIAN = 'ca',
  CHAMORRO = 'ch',
  CHECHEN = 'ce',
  CHICHEWA_CHEWA_NYANJA = 'ny',
  CHINESE = 'zh',
  CHUVASH = 'cv',
  CORNISH = 'kw',
  CORSICAN = 'co',
  CREE = 'cr',
  CROATIAN = 'hr',
  CZECH = 'cs',
  DANISH = 'da',
  DIVEHI_DHIVEHI_MALDIVIAN = 'dv',
  DUTCH_FLEMISH = 'nl',
  DZONGKHA = 'dz',
  ENGLISH = 'en',
  ESPERANTO = 'eo',
  ESTONIAN = 'et',
  EWE = 'ee',
  FAROESE = 'fo',
  FIJIAN = 'fj',
  FINNISH = 'fi',
  FRENCH = 'fr',
  FULAH = 'ff',
  GALICIAN = 'gl',
  GEORGIAN = 'ka',
  GERMAN = 'de',
  GREEK_MODERN = 'el',
  GUARANI = 'gn',
  GUJARATI = 'gu',
  HAITIAN_HAITIAN_CREOLE = 'ht',
  HAUSA = 'ha',
  HEBREW = 'he',
  HERERO = 'hz',
  HINDI = 'hi',
  HIRI_MOTU = 'ho',
  HUNGARIAN = 'hu',
  INTERLINGUA_INTERNATIONAL_AUXILIARY_LANGUAGE_ASSOCIATION = 'ia',
  INDONESIAN = 'id',
  INTERLINGUE_OCCIDENTAL = 'ie',
  IRISH = 'ga',
  IGBO = 'ig',
  INUPIAQ = 'ik',
  IDO = 'io',
  ICELANDIC = 'is',
  ITALIAN = 'it',
  INUKTITUT = 'iu',
  JAPANESE = 'ja',
  JAVANESE = 'jv',
  KALAALLISUT_GREENLANDIC = 'kl',
  KANNADA = 'kn',
  KANURI = 'kr',
  KASHMIRI = 'ks',
  KAZAKH = 'kk',
  CENTRAL_KHMER = 'km',
  KIKUYU_GIKUYU = 'ki',
  KINYARWANDA = 'rw',
  KIRGHIZ_KYRGYZ = 'ky',
  KOMI = 'kv',
  KONGO = 'kg',
  KOREAN = 'ko',
  KURDISH = 'ku',
  KUANYAMA_KWANYAMA = 'kj',
  LATIN = 'la',
  LUXEMBOURGISH_LETZEBURGESCH = 'lb',
  GANDA = 'lg',
  LIMBURGAN_LIMBURGER_LIMBURGISH = 'li',
  LINGALA = 'ln',
  LAO = 'lo',
  LITHUANIAN = 'lt',
  LUBA_KATANGA = 'lu',
  LATVIAN = 'lv',
  MANX = 'gv',
  MACEDONIAN = 'mk',
  MALAGASY = 'mg',
  MALAY = 'ms',
  MALAYALAM = 'ml',
  MALTESE = 'mt',
  MAORI = 'mi',
  MARATHI = 'mr',
  MARSHALLESE = 'mh',
  MONGOLIAN = 'mn',
  NAURU = 'na',
  NAVAJO_NAVAHO = 'nv',
  NORTH_NDEBELE = 'nd',
  NEPALI = 'ne',
  NDONGA = 'ng',
  NORWEGIAN_BOKMAL = 'nb',
  NORWEGIAN_NYNORSK = 'nn',
  NORWEGIAN = 'no',
  SICHUAN_YI_NUOSU = 'ii',
  SOUTH_NDEBELE = 'nr',
  OCCITAN = 'oc',
  OJIBWA = 'oj',
  CHURCH_SLAVIC_OLD_SLAVONIC_CHURCH_SLAVONIC_OLD_BULGARIAN_OLD_CHURCH_SLAVONIC = 'cu',
  OROMO = 'om',
  ORIYA = 'or',
  OSSETIAN_OSSETIC = 'os',
  PUNJABI_PANJABI = 'pa',
  PALI = 'pi',
  PERSIAN = 'fa',
  POLISH = 'pl',
  PASHTO_PUSHTO = 'ps',
  PORTUGUESE = 'pt',
  QUECHUA = 'qu',
  ROMANSH = 'rm',
  RUNDI = 'rn',
  ROMANIAN_MOLDAVIAN_MOLDOVAN = 'ro',
  RUSSIAN = 'ru',
  SANSKRIT = 'sa',
  SARDINIAN = 'sc',
  SINDHI = 'sd',
  NORTHERN_SAMI = 'se',
  SAMOAN = 'sm',
  SANGO = 'sg',
  SERBIAN = 'sr',
  GAELIC_SCOTTISH_GAELIC = 'gd',
  SHONA = 'sn',
  SINHALA_SINHALESE = 'si',
  SLOVAK = 'sk',
  SLOVENIAN = 'sl',
  SOMALI = 'so',
  SOUTHERN_SOTHO = 'st',
  SPANISH_CASTILIAN = 'es',
  SUNDANESE = 'su',
  SWAHILI = 'sw',
  SWATI = 'ss',
  SWEDISH = 'sv',
  TAMIL = 'ta',
  TELUGU = 'te',
  TAJIK = 'tg',
  THAI = 'th',
  TIGRINYA = 'ti',
  TIBETAN = 'bo',
  TURKMEN = 'tk',
  TAGALOG = 'tl',
  TSWANA = 'tn',
  TONGA_TONGA_ISLANDS = 'to',
  TURKISH = 'tr',
  TSONGA = 'ts',
  TATAR = 'tt',
  TWI = 'tw',
  TAHITIAN = 'ty',
  UIGHUR_UYGHUR = 'ug',
  UKRAINIAN = 'uk',
  URDU = 'ur',
  UZBEK = 'uz',
  VENDA = 've',
  VIETNAMESE = 'vi',
  VOLAPUK = 'vo',
  WALLOON = 'wa',
  WELSH = 'cy',
  WOLOF = 'wo',
  WESTERN_FRISIAN = 'fy',
  XHOSA = 'xh',
  YIDDISH = 'yi',
  YORUBA = 'yo',
  ZHUANG_CHUANG = 'za',
  ZULU = 'zu',
}
